import java.util.Properties;
import java.awt.*;
import java.net.*;
import java.applet.*;
import com.ibm.eNetwork.ECL.*;

public class LaunchBase extends Frame
{
   Label Title;
   Button LogonButton;
   Button LogoutButton;
   Button FileListButton;
   Checkbox DebugCheckBox;

   Object callLock = new Object();

   // Flag to denote if this is an application or an applet
   boolean isApplication;

   // Data that we need to keep track of.
   static CInitData InitDataForECL;

   public LaunchBase()
   {
   }

   public LaunchBase(boolean isApplicationIfTrue, Applet callingApplet)
   {
      isApplication = isApplicationIfTrue;

      InitDataForECL = new CInitData();
      InitDataForECL.isApplication = isApplicationIfTrue;
      InitDataForECL.OriginatingApplet = callingApplet;

      DoTheRest();
   }

   public LaunchBase(boolean isApplicationIfTrue)
   {
      isApplication = isApplicationIfTrue;

      InitDataForECL = new CInitData();
      InitDataForECL.isApplication = isApplicationIfTrue;

      DoTheRest();
   }

   public void DoTheRest()
   {
      setLayout(null);
      setBackground(Color.lightGray);
      resize(insets().left + insets().right + 400,insets().top + insets().bottom + 250);

      Title = new java.awt.Label("   Host Applications On-Demand             ");
      Title.reshape(insets().left + 25,insets().top + 35,325,25);
      Title.setFont(new Font("Dialog", Font.BOLD, 18));
      add(Title);

      LogonButton = new java.awt.Button("Logon");
      LogonButton.reshape(insets().left + 70,insets().top + 75,100,25);
      add(LogonButton);

      LogoutButton = new java.awt.Button("Logout");
      LogoutButton.reshape(insets().left + 230,insets().top + 75,100,25);
      add(LogoutButton);

      FileListButton = new java.awt.Button("FileList");
      FileListButton.reshape(insets().left + 70,insets().top + 125,100,25);
      add(FileListButton);

      DebugCheckBox = new java.awt.Checkbox("PS_DEBUGGER ON (Display Screen)");
      DebugCheckBox.reshape(insets().left + 70,insets().top + 175,260,25);
      add(DebugCheckBox);


      LogoutButton.disable();
      FileListButton.disable();

      setTitle("Host Applications On-Demand");

      center(this);

   }

   static public void center(Window windowInstance)
   { Dimension screenSize = windowInstance.getToolkit().getScreenSize();
     Dimension windowSize = windowInstance.size();
     windowInstance.move((screenSize.width / 2) - (windowSize.width / 2), (screenSize.height / 2) - (windowSize.height / 2));
   }


   public synchronized void show()
   { super.show();
   }

   public void removeLaunchBase()
   {
      if (InitDataForECL.s != null)
      { // ensure disposal of ECL session.
        InitDataForECL.s.dispose();
      }

      dispose();

      if (isApplication)
      { System.exit(0);
      }
   }


   public boolean handleEvent(Event event)
   {

     if (event.id == Event.WINDOW_DESTROY)
     {
       removeLaunchBase();
       return true;
     }



     if (event.id == Event.ACTION_EVENT)
     {
        if ( event.target == LogonButton)
        {
          // instantiate LogonLaunchApp to obtain logon parameters and
          // to perform the logon.
          LogonLaunchApp HLP_LogonLaunchApp = new LogonLaunchApp(InitDataForECL);
          HLP_LogonLaunchApp.show();

          // We should use more of a state table for the button states.
          // But for this sample assume the user will follow a normal flow.
          LogoutButton.enable();
          FileListButton.enable();
          DebugCheckBox.disable();

          return true;
        }

        if ( event.target == LogoutButton)
        { // instantiate Logout Thread to perform the logout
          SALogoutLaunch LogoutLaunchThread = new SALogoutLaunch(InitDataForECL.ps, callLock);
          LogoutLaunchThread.start();

          LogoutButton.disable();
          LogonButton.disable();
          FileListButton.disable();

          // Wait for the thread the finish before returning back to the user.
          // (a thread "join" method could be used here, but that was found not
          // to work in all the java environments that were tested)
          synchronized(callLock)
          {
            try
            {
              callLock.wait();
            }
            catch(InterruptedException e)
            { System.out.println("LogonLaunchApp: wait Exception");
            }
          }

          removeLaunchBase();
          return true;
        }

        if ( event.target == FileListButton)
        { // instantiate FilelLaunchApp to obtain the Filelist parameters,
          // perform the filelist command, and display the filelist results
          FilelLaunchApp HLP_FileListLaunchApp = new FilelLaunchApp(InitDataForECL.ps,
                                                                    InitDataForECL.oia);
          HLP_FileListLaunchApp.show();

          return true;
        }

        // This allows for the "debug" screen to be display.  This is a window
        // which display the current emulator screen.  It is display only and
        // does not allow for input.
        if ( event.target == DebugCheckBox)
        { if (DebugCheckBox.getState())
          {
            InitDataForECL.DebugOn = true;
          }
          else
          { InitDataForECL.DebugOn = false;
          }

          return true;
        }
     }

     return super.handleEvent(event);
   }

}

