import java.util.Properties;
import java.awt.*;
import java.net.*;
import java.applet.*;
import com.ibm.eNetwork.ECL.*;

public class LogonLaunchApp extends Frame {

   Label Title;
   Label L_VMSystem;
   Label L_UserID;
   Label L_Password;
   Label L_TNServerAddr;

   Button LogonButton;

   TextField TF_VMSystem;
   TextField TF_UserID;
   TextField TF_Password;
   TextField TF_TNServerAddr;

   CInitData InitDataForECL;
   Object callLock = new Object();

   public LogonLaunchApp(CInitData InitialData)
   {
      char chStar = '*';

      // Keep initial data
      InitDataForECL = InitialData;

      setLayout(null);
      setBackground(Color.lightGray);
      resize(insets().left + insets().right + 450,  insets().top + insets().bottom + 260);

      Title = new java.awt.Label("Logon");
      Title.reshape(insets().left + 10,insets().top + 25,125,25);
      Title.setFont(new Font("Dialog", Font.BOLD, 18));
      add(Title);

      // Obtain the following information from the user:
      // - TN Server Addr/Name, can be a redirector.
      // - 3270 Host System Name, if the ECL application is going directly
      //   to a host system, then this may not be needed.  And some code
      //   in the sample will have to be changed.
      // - User ID - User's Host User ID.
      // - Password - User's Host Password for the above User ID

      L_TNServerAddr = new java.awt.Label("TN3270 Server Addr/Name");
      L_TNServerAddr.reshape(insets().left + 10,insets().top + 60,175,25);
      add(L_TNServerAddr);
      TF_TNServerAddr = new java.awt.TextField();
      TF_TNServerAddr.reshape(insets().left + 195,insets().top + 60,225,25);
      add(TF_TNServerAddr);

      L_VMSystem = new java.awt.Label("3270 Host System");
      L_VMSystem.reshape(insets().left + 10,insets().top + 95,175,25);
      add(L_VMSystem);
      TF_VMSystem = new java.awt.TextField();
      TF_VMSystem.reshape(insets().left + 195,insets().top + 95,225,25);
      add(TF_VMSystem);

      L_UserID = new java.awt.Label("User ID");
      L_UserID.reshape(insets().left + 10,insets().top + 130,175,25);
      add(L_UserID);
      TF_UserID = new java.awt.TextField();
      TF_UserID.reshape(insets().left + 195,insets().top + 130,225,25);
      add(TF_UserID);

      L_Password = new java.awt.Label("Password");
      L_Password.reshape(insets().left + 10,insets().top + 165,175,25);
      add(L_Password);
      TF_Password = new java.awt.TextField();
      TF_Password.reshape(insets().left + 195,insets().top + 165,225,25);
      TF_Password.setEchoCharacter(chStar);
      add(TF_Password);

      LogonButton = new java.awt.Button("Logon");
      LogonButton.reshape(insets().left + 10,insets().top + 200,410,25);
      add(LogonButton);

      setTitle("Host Applications On-Demand");

      center(this);
   }

   static public void center(Window windowInstance) 
   {
       Dimension screenSize = windowInstance.getToolkit().getScreenSize();
       Dimension windowSize = windowInstance.size();
       windowInstance.move((screenSize.width / 2) - (windowSize.width / 2), (screenSize.height / 2) - (windowSize.height / 2));
   }

   public synchronized void show() 
   {
      super.show();
   }

   public void removeLogon()
   { 
      dispose();
   }

   public boolean keyDown(Event evt, int key)
   {
     if (key == 9)                                   // TAB key is 9
     { // Tab Key was pressed
       if ( evt.target == TF_TNServerAddr)
       { if (evt.shiftDown()) { LogonButton.requestFocus(); }
         else                 { TF_VMSystem.requestFocus(); }
       }

       if ( evt.target == TF_VMSystem)
       { if (evt.shiftDown()) { TF_TNServerAddr.requestFocus(); }
         else                 { TF_UserID.requestFocus();       }
       }

       if ( evt.target == TF_UserID)
       { if (evt.shiftDown()) { TF_VMSystem.requestFocus(); }
         else                 { TF_Password.requestFocus(); }
       }

       if ( evt.target == TF_Password)
       { if (evt.shiftDown()) { TF_UserID.requestFocus();   }
         else                 { LogonButton.requestFocus(); }
       }

       if ( evt.target == LogonButton)
       { if (evt.shiftDown()) { TF_Password.requestFocus();     }
         else                 { TF_TNServerAddr.requestFocus(); }
       }
       return true;
     }

     if (key == 10)            // ENTER key is 10
     { postEvent(new Event(LogonButton, Event.ACTION_EVENT, null));
       return true;
     }

     return false;
   }


   public boolean handleEvent(Event event)
   {
     if (event.id == Event.WINDOW_DESTROY)
     {
       removeLogon();
       return true;
     }

     if (event.id == Event.ACTION_EVENT)
     {
        if ( event.target == LogonButton)
        { // Read Input Fields

          int    colonIndex;
          String port = null;
          
          LogonButton.disable();

          // Need the TN Server Addr/Name in order to make a connection
          // to the Host via the Host Access Libraries.
          InitDataForECL.hostName = TF_TNServerAddr.getText();
          
          // Parse out the port number if specified
          if ((colonIndex = InitDataForECL.hostName.indexOf(":")) != -1)
          {
             port = InitDataForECL.hostName.substring(colonIndex+1);
             InitDataForECL.hostName = InitDataForECL.hostName.substring(0, colonIndex);
          }

          // Set up the properties for this session
          Properties p = new Properties();

          // The SESSION_HOST is the TN Server Addr/Name
          p.put(ECLSession.SESSION_HOST, InitDataForECL.hostName);

          // The port number to use to connect to the TN server or Redirector
          if (port != null)
             p.put(ECLSession.SESSION_HOST_PORT, port);

          // The Service Manager is the name of the server that is running the 
          // NCOD Service Manager (for persistent logging and tracing).
          // p.put(ECLSession.SESSION_SERVICE_MGR_HOST, InitDataForECL.hostName);
          
          if (InitDataForECL.isApplication == false)
          { // For Applets, the Applet instance needs to be set up.
            p.put(ECLSession.SESSION_APPLET, InitDataForECL.OriginatingApplet);
          }

          if (InitDataForECL.DebugOn == true)
          { // This allows for the debug screen to appear
            // "ON" is just my own value, any string will work.
            // To turn this off, don't set the parameter to any value.
            p.put(ECLSession.SESSION_PS_DEBUGGER, new String("ON"));
          }

          System.out.println("Properties:  " + p.toString());
          
          try
          { // Instantiate the session.
            InitDataForECL.s = new ECLSession(p);
          }
          catch (ECLErr e)
          { // Use the GetMsgText() method to print out error messages
            System.out.println(e.GetMsgText());
            System.out.println("Exception from ECLSession constructor --> " + e.toString());
            return true;
          }

          // Now start the communications with the Host system.
          // The debug screen should now be present, with the first screen
          // appearing, if SESSION_PS_DEBUGGER was on.
          InitDataForECL.s.StartCommunication();

          // Get the instance of the presentation space and oia area
          InitDataForECL.ps  = InitDataForECL.s.GetPS();
          InitDataForECL.oia = InitDataForECL.s.GetOIA();

          // Set up the logon data the the user filled in.
          CLogonData LogonData = new CLogonData();
          LogonData.S_VMSystem = TF_VMSystem.getText();
          LogonData.S_UserID   = TF_UserID.getText();
          LogonData.S_Password = TF_Password.getText();

          // This thread will handle the logon interaction with the 3270 screens.
          SALogon LogonThread = new SALogon(InitDataForECL.ps, InitDataForECL.oia,
                                            LogonData, callLock);
          LogonThread.start();


          // Wait for the thread the finish before returning back to the user.
          // (a thread "join" method could be used here, but that was found not
          // to work in all the java environments that were tested)
          synchronized(callLock)
          {
            try
            {
              callLock.wait();
            }
            catch(InterruptedException e)
            { System.out.println("LogonLaunchApp: wait Exception");
            }
          }

          removeLogon();

          return true;
        }
     }

     return super.handleEvent(event);
   }
}
