import com.ibm.eNetwork.ECL.*;
import java.util.*;

class SAVMLogin extends ScreenAction implements HostLPConstants
{
   // Our main logon screen has the footprint (Near the bottom of the
   // screen on one line it ask for the USERID, and on a line below that
   // it ask for a PASSWORD.  Put your footprint here if it
   // is different.
   final static String[] VM_LOGIN = { "USERID   ===>",
                                      "PASSWORD ===>"
                                    };

   public SAVMLogin()
   {
      SetFootprint(VM_LOGIN, 190);
      // 190 - start looking midway through the third row.
      // This is arbitrary, our USERID appears down on row 20.
   }

   public boolean recognizes(ECLPS ps, ECLOIA oia,
                             ScreenState MyScreenState, CLogonData LogonData)
   {
      int i;
      int pos = startPos;

      for (i = 0; i < rows; i++)
      {
         // Start at the desired position on the screen, and check to see
         // if the strings listed in the footprint, are on this screen.
         // Search for the strings in the order they were given.
         // If one does not appear, then this screen does not
         // match the desired footprint.
         pos = ps.SearchText(buffer[i], pos, ps.SEARCH_FORWARD);
         if (pos == 0)
            return false;
      }

     // If we made it here, then the screen was recognized.
     // Wait for presentation layer to "settle down"
     // as described before in SALogon.java
      try { Thread.sleep(100); }
      catch (InterruptedException e)
      { /* System.out.println("SAFilel: catch sleep InterruptedException"); */ }

     while (oia.InputInhibited() != oia.INHIBIT_NOTINHIBITED)
        try { Thread.sleep(100); }
        catch (InterruptedException e)
        { /* System.out.println("SAFilel: catch sleep InterruptedException"); */ }

     // Take action on this screen.  Which means to input the username and password.
     TakeActionOnScreen(ps, MyScreenState, LogonData);

     return true;
   }

   public void TakeActionOnScreen (ECLPS ps, ScreenState MyScreenState, CLogonData LogonData)
   {
     // Check for the state, so that we only enter this clause once per logon
     if (MyScreenState.GetState() == SS_READY_FOR_LOGON)
     {
       // Change the screen state, so that on another possible PS Event
       // (screen update) we don't again recognize the same screen, and
       // then call this action method twice, thus confusing us and the
       // screens!
       MyScreenState.UpdateState(SS_LOGON_STARTED);

       try
       {
         // Fill in the user name at the current cursor postion.
         ps.SendKeys(LogonData.S_UserID);
         if (LogonData.S_UserID.length() < 8)
         { // if necessary tab the cursor to the next field.
           // again, if your logon screen is different, you may
           // need to change this code.
           ps.SendKeys(ps.FWDTAB_STR);
         }
         // Enter the password in this next field, and then "enter".
         ps.SendKeys(LogonData.S_Password);
         ps.SendKeys(ps.ENTER_STR);
       }
       catch(Exception e)
       { System.out.println("SAVMLogin: SendKeys(userid, psw) Exception");
       }

     }
   }

}
