//-------------------------------------------------------------------
// ECLField.SetText
//
// Set all the unprotected fields on the screen.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample36 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample36()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

      ECLPS        ps;           // ps object              
      ECLFieldList fieldList;    // field list object
      ECLField     field;        // field object
      int          count = 0;

      try {
         ps = s.GetPS();                     // Get PS object
         fieldList = ps.GetFieldList(ECLFieldList.ALL_PLANES);     // Get field list

         // Get first unprotected field
         field = fieldList.GetFirstField(ECLFieldList.UNPROTECTED_FIELD); 
         
         while (field != null) {
             // Set the text to something we can identify
             field.SetText(String.valueOf(count) + "Field" + String.valueOf(count));    
             //field.SetString(String.valueOf(count) + "Field" + String.valueOf(count));    
             
             // Get next unprotected field
             field = fieldList.GetNextField(field, ECLFieldList.UNPROTECTED_FIELD);
             count++;
         }
      }
      catch (ECLErr e) {
        System.out.println("Sample36(): " + e.GetMsgText());
      }

   } // end sample

}
