//-------------------------------------------------------------------
// ECLField.GetAttribute()
//
// Iterate over list of fields and print each fields attribute
// value.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample38 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample38()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {
 
       ECLPS        ps;           // PS object
       ECLFieldList fieldList;    // field list object
       ECLField     field;        // field object

       ps = s.GetPS();                     // Get instance of ECLPS   

       try {
          fieldList = ps.GetFieldList(ECLFieldList.ALL_PLANES);                   // Get the field list

          for (field = fieldList.GetFirstField(ECLFieldList.ALL_FIELDS);          // First field
               field != null;                                                     // While more
               field = fieldList.GetNextField(field, ECLFieldList.ALL_FIELDS)) {  // Next field

              System.out.println("Attribute value for field at " +
                                 formatString(field.GetStartRow(),2,0) + ","+
                                 formatString(field.GetStartCol(),3,0) + " is: 0x" +
                                 Integer.toHexString(field.GetAttribute()));
          }
       } catch (ECLErr e) { System.out.println("Sample38(): " + e.GetMsgText()); }
  } // end sample

   // Utility method used to format strings
   private String formatString(int num, int length, int justify)
   {
     String numString = String.valueOf(num);
     int numLength = numString.length();
     StringBuffer retBuffer = new StringBuffer();

     if (numLength == length)
        return numString.toString();
     if (numLength > length)
        return numString.toString().substring(0,length);

     if (justify == 0)  // right justify
     {
        for (int i = length; numLength < i; i--)
           retBuffer.append('0');

        retBuffer.append(numString);
     }
     else               // left justify
     {
        retBuffer.append(numString);

        for (int i = length; numLength < i; i--)
           retBuffer.append(' ');
     }


     return retBuffer.toString();
   }

}
