//-------------------------------------------------------------------
// ECLPS.SendKeys()
//
// Sends a series of keystrokes, including 3270 function keys, to
// the host.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample62 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample62()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

      ECLPS ps = s.GetPS();   // Get instance of ECLPS

      // The following string will erase from the current cursor
      // position to the end of the field, and then type the given
      // characters into the field.
      String SendStr = new String("[eraseeof]Host On-Demand is really cool!");

      // Note that no keystrokes will be sent to a protected field.
      try {
        ps.SendKeys(SendStr);        // Do it at the current cursor position
        ps.SendKeys(SendStr, 10, 1); // Again at row 10 column 1
        ps.SendKeys(SendStr, 11, 70);// Again at row 11 column 70
        ps.SendKeys(SendStr, 481);   // Again at row 6 column 1 (assumes screen is 24x80)
      } catch (ECLErr e) {
         System.out.println("Sample62(): " + e.GetMsgText());
      }

   } // end sample

}
