//-------------------------------------------------------------------
// ECLPS.GetScreenRect()
//
// Get rectangular parts of the host screen.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample66 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample66()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

      ECLPS  ps;                     // PS object
      char[] buff = new char[4000];  // buffer
      int    len = 0;

      ps = s.GetPS();

      try {
         // Get first 2 lines of the screen text
         len = ps.GetScreenRect(buff, buff.length, 1, 1, 2, 80, ECLPS.TEXT_PLANE);
         // Note results are placed in buffer end-to-end with no line delimiters
         System.out.println("Contents of rectangular screen area:  " + String.valueOf(buff, 0, len));

         // Get last 2 lines of the screen
         len = ps.GetScreenRect(buff, buff.length,
                          ps.GetSizeRows()-1,
                          1,
                          ps.GetSizeRows(),
                          ps.GetSizeCols(),
                          ECLPS.TEXT_PLANE);
         System.out.println("Contents of rectangular screen area:  " + String.valueOf(buff, 0, len));

         // Get just a part of the screen
         len = ps.GetScreenRect(buff, buff.length,
                          3, 24,
                          7, 27,
                          ECLPS.TEXT_PLANE);
         System.out.println("Contents of rectangular screen area defined by (3,24) and (7,27):");
         for (int i=0; i < 5; i++)
            System.out.println(String.valueOf(buff, i*4, 4));

         // Same as previous (specify any 2 oposite corners of the rectangle)
         len = ps.GetScreenRect(buff, buff.length,
                          13, 5,
                          3,  71,
                          ECLPS.TEXT_PLANE);
         System.out.println("Contents of rectangular screen area:");
         for (int i=0; i < 11; i++)
            System.out.println(String.valueOf(buff, i*67, 67));
      } catch (ECLErr e) { System.out.println("Sample66(): " + e.GetMsgText()); }

   } // end sample

}
